/*
    For Hobbytronics Leonardo CAN BUS board
    Downloading of CAN Shield library needed
    This programm sends Ignition ON signal to the Alternator, then listens what the Alternator has to say and
    repeats the Ignition ON signal sending process if no more signals from Alternator are coming. The Alternator answers every time :) 
*/

#include <SPI.h>
#include <can-serial.h>
#include <mcp_can.h>
#include <mcp2515_can.h>
#include <Arduino.h>                 //outside programs are added

#define CANint 2     // The compiler will replace any mention of CANint with the value 2 at compile time.
#define LED2 8
#define LED3 7

unsigned char len = 0;
unsigned char buf[8];
unsigned long ID = 0;                  //unsigned long nuber range from 0 to 4,294,967,295 or 4 bytes ehk 32bits
unsigned long line = 0;
unsigned long time;
const int SPI_CS_PIN = 17;         //CS pin MCP2515

mcp2515_can CAN(SPI_CS_PIN);       // Set CS to pin 17

void setup() {                     
  Serial.begin(115200);           //starting USB connection  with board
  
  while (!Serial) {               //waits USB connection to start up with board
    Serial.print("I will wait here forever...");            // statement
      delay(1000);                                         
  };
  
  pinMode(23, OUTPUT);      //makes pin 23 output
  digitalWrite(23, HIGH);   //turns onboard LED on

  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(CANint, INPUT);
  digitalWrite(LED2, LOW);
  
  Serial.println("CAN init:");

  if (CAN.begin(CAN_500KBPS) == CAN_OK) {
    Serial.println("Can Init Success");
  } else {
    Serial.println("Can Init Failed");
    while (1) {
      Serial.print("I will wait here forever...");
      delay(1000);
    }
  }

  Serial.println("Good to go!");
}

unsigned char stmp[4] = {46, 1, 35, 0};    //unsigned char stmp[8] = {46, 1, 35, 0, 0, 0, 0, 0};
void loop() {
    // send data:  id = 0x00, standrad frame, data len = 4(8), stmp: data buf
    stmp[3] = stmp[3] + 1;            //[7]
    if (stmp[3] == 100) {             //[7]
        stmp[3] = 0;                  //[7]
        stmp[2] = stmp[2] + 1;        //[6] [6]

        if (stmp[2] == 100) {        //[6]
            stmp[2] = 0;              //[6]
            stmp[1] = stmp[1] + 1;    //[5][5]
        }
    }

    CAN.sendMsgBuf(960, 0, 4, stmp);   //CAN.sendMsgBuf(0x3C0, 0, 8, stmp); for 8bytes of data
    delay(1);                       // send data per 100ms
   
 time = millis();
 
  if(CAN_MSGAVAIL == CAN.checkReceive()   && line < 10000 ) {          // Check to see whether data is read
    CAN.readMsgBufID(&ID, &len, buf);    // Read data
    
    //line = line + 1;  // It is possible to print line numbers after data (not nessesery)

 //if(ID == 416) {//|| ID == 338 || ID == 428 || ID == 416 || ID == 704 || ID == 336 || ID == 931) { //Add this line back in if you want to filter traffic   
      
                     //,HEX // If you want ID to be printed in HEX
      Serial.print(ID      ); // Output Header 
      Serial.print("\t");
      
      for(int i = 0; i<len; i++) { // Output 8 Bytes of data in Dec
        Serial.print(buf[i]);
        Serial.print("\t");
      }
     
      //Serial.print(time); // Timestamp
      Serial.print("\n");     //to the next line
      //Serial.println(line); // Line Number
     
  //}  //Add this } back if you are filtering traffic
    }
  
  delay(1);      
}